<template>
  <div>
    <div class="d-flex justify-content-between align-items-center mb-2">
      <h3>{{title}}</h3>
      <input placeholder="Search..." class="form-control" v-model="q" />
      <router-link class="btn btn-primary" :to="{name: 'group-new', query: {path: path}}">New</router-link>
    </div>

    <ul class="list-group">
      <li
        v-for="group in groups"
        :key="group._id"
        class="list-group-item d-flex justify-content-between align-items-center"
      >
        <div class>
          <router-link :to="`/groups/${group.path?group.path:''}${group.name}`">{{group.name}}</router-link>
          <br />
          <small>path={{group.path | showNull}}</small>
        </div>
        <div class="controls">
          <router-link :to="{name: 'group-edit', params: {id: group._id}}" class="text-muted">Edit</router-link>
        </div>
      </li>
    </ul>
  </div>
</template>

<script>
export default {
  props: {
    entities: {
      type: Array
    },
    title: {
      type: String,
      default: "Groups"
    },
    path: {
      type: String,
      default: null
    }
  },
  computed: {
    groups() {
      if (!this.q) {
        return this.entities;
      }

      return this.entities.filter(entity => {
        return entity.name.toLowerCase().indexOf(this.q) > -1;
      });
    }
  },
  data() {
    return {
      q: ""
    };
  }
};
</script>

<style scoped>
h2,
h3 {
  margin-bottom: 0px;
}

input {
  max-width: 30rem;
}
</style>